class _Assets {
  final List<String> assets;

  const _Assets({this.assets = const []});

  factory _Assets.fromJson(List<String> json) => _Assets(assets: json);

  factory _Assets.cloneFromOld(_Assets old, {List<String> assets}) =>
      _Assets(assets: assets ?? old.assets);

  _Assets add(String asset) => _Assets.cloneFromOld(
        this,
        assets: (Set<String>()
              ..addAll(assets)
              ..add(asset))
            .toList(),
      );

  _Assets addAll(List<String> assets) => _Assets.cloneFromOld(
        this,
        assets: (Set<String>()..addAll(this.assets)..addAll(assets)).toList(),
      );

  List<String> toJson() => assets;
}

class Flutter {
  final _Assets assets;

  const Flutter({this.assets = const _Assets()});

  factory Flutter.fromJson(Map<String, dynamic> json) {
    return Flutter(assets: json['assets']);
  }

  factory Flutter.cloneFromOld(Flutter old, {_Assets assets}) =>
      Flutter(assets: assets ?? old.assets);

  Flutter addAsset(String asset) =>
      Flutter.cloneFromOld(this, assets: assets.add(asset));

  Flutter addAssets(List<String> assets) =>
      Flutter.cloneFromOld(this, assets: this.assets.addAll(assets));

  bool get isNotEmpty => assets.assets.isNotEmpty;

  Map<String, dynamic> toJson() => {
        'assets': assets.assets,
      };
}
